unit fmBruchrechner;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, mKnopf, mTextfeld, mTBruch, mTBruchrechner,
  mEtikett;

type
  TBruchrechnerFormular = class(TForm)
    hatKnopfPlus: TKnopf;
    hatKnopfMinus: TKnopf;
    hatKnopfMal: TKnopf;
    hatKnopfDurch: TKnopf;
    hatKnopfEnde: TKnopf;
    hatTextfeldZ1: TTextfeld;
    hatTextfeldN1: TTextfeld;
    hatTextfeldZ2: TTextfeld;
    hatTextfeldN2: TTextfeld;
    hatTextfeldZ3: TTextfeld;
    hatTextfeldN3: TTextfeld;
    hatEtikettBruchstrich1: TEtikett;
    hatEtikettBruchstrich2: TEtikett;
    hatEtikettBruchstrich3: TEtikett;
    hatEtikettGleich: TEtikett;
    procedure FormCreate(Sender: TObject);
    procedure hatTextfeldZ1TextGeaendert(Sender: TObject);
    procedure hatTextfeldN1TextGeaendert(Sender: TObject);
    procedure hatTextfeldZ2TextGeaendert(Sender: TObject);
    procedure hatTextfeldN2TextGeaendert(Sender: TObject);
    procedure hatKnopfPlusGeklickt(Sender: TObject);
    procedure hatKnopfMinusGeklickt(Sender: TObject);
    procedure hatKnopfMalGeklickt(Sender: TObject);
    procedure hatKnopfDurchGeklickt(Sender: TObject);
    procedure hatKnopfEndeGeklickt(Sender: TObject);
  private
    hatBruch1,hatBruch2,hatErgebnisbruch:TBruch;
    hatBruchrechner:TBruchrechner;
  public
    { Public-Deklarationen }
  end;

var
  BruchrechnerFormular: TBruchrechnerFormular;

implementation

{$R *.DFM}

procedure TBruchrechnerFormular.FormCreate(Sender: TObject);
begin
  hatBruch1:=TBruch.init(2,3);
  hatTextfeldZ1.setzeInhalt(hatBruch1.zaehler);
  hatTextfeldN1.setzeInhalt(hatBruch1.nenner);

  hatBruch2:=TBruch.init(1,6);
  hatTextfeldZ2.setzeInhalt(hatBruch2.zaehler);
  hatTextfeldN2.setzeInhalt(hatBruch2.nenner);

  hatErgebnisbruch:=TBruch.init(1,1);
  hatTextfeldZ3.setzeInhalt(hatErgebnisbruch.zaehler);
  hatTextfeldN3.setzeInhalt(hatErgebnisbruch.nenner);

  hatBruchrechner:=TBruchrechner.init(hatBruch1,hatBruch2,hatErgebnisbruch);
end;

procedure TBruchrechnerFormular.hatTextfeldZ1TextGeaendert(
  Sender: TObject);
begin
  if hatTextfeldZ1.inhaltIstZahl
    then  hatBruch1.setzeZaehler(hatTextfeldZ1.inhaltAlsGanzeZahl);
end;

procedure TBruchrechnerFormular.hatTextfeldN1TextGeaendert(
  Sender: TObject);
begin
  if hatTextfeldZ1.inhaltIstZahl and not(hatTextfeldZ1.inhaltAlsZahl=0)
  then hatBruch1.setzeNenner(hatTextfeldN1.inhaltAlsGanzeZahl);

end;

procedure TBruchrechnerFormular.hatTextfeldZ2TextGeaendert(
  Sender: TObject);
begin
 if hatTextfeldZ2.inhaltIstZahl
  then  hatBruch2.setzeZaehler(hatTextfeldZ2.inhaltAlsGanzeZahl);

end;

procedure TBruchrechnerFormular.hatTextfeldN2TextGeaendert(
  Sender: TObject);
begin
  if hatTextfeldZ2.inhaltIstZahl and not(hatTextfeldZ2.inhaltAlsZahl=0)
  then hatBruch2.setzeNenner(hatTextfeldN2.inhaltAlsGanzeZahl);
end;

procedure TBruchrechnerFormular.hatKnopfPlusGeklickt(Sender: TObject);
begin
  hatBruchrechner.addiere;
  hatTextfeldZ3.setzeInhalt(hatErgebnisbruch.zaehler);
  hatTextfeldN3.setzeInhalt(hatErgebnisbruch.nenner);
end;

procedure TBruchrechnerFormular.hatKnopfMinusGeklickt(Sender: TObject);
begin
  hatBruchrechner.subtrahiere;
  hatTextfeldZ3.setzeInhalt(hatErgebnisbruch.zaehler);
  hatTextfeldN3.setzeInhalt(hatErgebnisbruch.nenner);
end;

procedure TBruchrechnerFormular.hatKnopfMalGeklickt(Sender: TObject);
begin
  hatBruchrechner.multipliziere;
  hatTextfeldZ3.setzeInhalt(hatErgebnisbruch.zaehler);
  hatTextfeldN3.setzeInhalt(hatErgebnisbruch.nenner);
end;

procedure TBruchrechnerFormular.hatKnopfDurchGeklickt(Sender: TObject);
begin
  hatBruchrechner.dividiere;
  hatTextfeldZ3.setzeInhalt(hatErgebnisbruch.zaehler);
  hatTextfeldN3.setzeInhalt(hatErgebnisbruch.nenner);
end;

procedure TBruchrechnerFormular.hatKnopfEndeGeklickt(Sender: TObject);
begin
 self.close;
end;

end.
