UNIT mTBruch;

interface

uses   mSuM;
// Uses-Klausel ggf. anpassen

type
   TBruch = CLASS

     // Attribute
     public
        zNenner : GanzeZahl;
        zZaehler : GanzeZahl;

     // Methoden
     private
        function ggt(pZahl1,pZahl2:GanzeZahl) : GanzeZahl;
     public
        constructor init(pZaehler,pNenner:GanzeZahl);
        procedure erweitereUm(pZahl:GanzeZahl);
        procedure kehrbruch;
        procedure kuerzeUm(pZahl:GanzeZahl);
        procedure kuerzeVoll;
        procedure setzeNenner(pNenner:GanzeZahl);
        procedure setzeZaehler(pZaehler:GanzeZahl);
        function dezimalwert : Zahl;
        function nenner : GanzeZahl;
        function zaehler : GanzeZahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TBruch: Methodendefinition 
//+---------------------------------------------------------------------

//-------- ggt (private) -----------------------------------------------
function TBruch.ggt(pZahl1,pZahl2:GanzeZahl) : GanzeZahl;
begin
  if pZahl1<0 then pZahl1:=-pZahl1;
  if pZahl2<0 then pZahl2:=-pZahl2;
  
  if pZahl1=pZahl2 then result:=pZahl1;
  if pZahl1>pZahl2 then result:=self.ggt(pZahl1-pZahl2, pZahl2);
  if pZahl1<pZahl2 then result:=self.ggt(pZahl1, pZahl2-pZahl1);
end;

{function Bruch.ggt(pZahl1,pZahl2:GanzeZahl):GanzeZahl;  // iterativ
begin
  while not(pZahl1=pZahl2) do
    if pZahl1<pZahl2
      then pZahl2:=pZahl2-pZahl1
      else pZahl1:=pZahl1-pZahl2;
  result := pZahl1;
end;}

//-------- init (public) -----------------------------------------------
constructor TBruch.init(pZaehler,pNenner:GanzeZahl);
begin
  zZaehler:=pZaehler;
  zNenner:=pNenner;
end;

//-------- erweitereUm (public) ----------------------------------------
procedure TBruch.erweitereUm(pZahl:GanzeZahl);
begin
  zZaehler:=zZaehler * pZahl;
  zNenner:=zNenner * pZahl;
end;

//-------- kehrbruch (public) ------------------------------------------
procedure TBruch.kehrbruch;
  var lTausch : GanzeZahl;
begin
  lTausch:=zZaehler;
  zZaehler:=zNenner;
  zNenner:=lTausch;
end;

//-------- kuerzeUm (public) -------------------------------------------
procedure TBruch.kuerzeUm(pZahl:GanzeZahl);
begin
  zZaehler:=zZaehler div pZahl;
  zNenner:=zNenner div pZahl;
end;

//-------- kuerzeVoll (public) -----------------------------------------
procedure TBruch.kuerzeVoll;
begin
 self.kuerzeUm(ggt(zZaehler,zNenner));
end;

//-------- setzeNenner (public) ----------------------------------------
procedure TBruch.setzeNenner(pNenner:GanzeZahl);
begin
  zNenner:=pNenner;
end;

//-------- setzeZaehler (public) ---------------------------------------
procedure TBruch.setzeZaehler(pZaehler:GanzeZahl);
begin
  zZaehler:=pZaehler;
end;

//-------- dezimalwert (public) ----------------------------------------
function TBruch.dezimalwert : Zahl;
begin
  result:=zZaehler/zNenner;
end;

//-------- nenner (public) ---------------------------------------------
function TBruch.nenner : GanzeZahl;
begin
  result:=zNenner;
end;

//-------- zaehler (public) --------------------------------------------
function TBruch.zaehler : GanzeZahl;
begin
  result:=zZaehler;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TBruch.gibFrei;
begin
end;

end.
