UNIT mTBruchrechnerAnwendung;

interface

uses      mSum,mTEreignisVerteilerAnwendung,
         mTRechteckKnopf,mTKnopf,mTSuMTextFeld,
         mTBruch,mTBruchrechner;
// Uses-Klausel ggf. anpassen

type
   TBruchrechnerAnwendung = CLASS(TEreignisVerteilerAnwendung)

     // Attribute
     private
        meinStift : BuntStift;
        hatBruch1 : TBruch;
        hatBruch2 : TBruch;
        hatErgebnisbruch : TBruch;
        hatBruchrechner : TBruchrechner;
        hatBeendenKnopf : TRechteckKnopf;
        hatDurchKnopf : TRechteckknopf;
        hatMalKnopf : TRechteckknopf;
        hatMinusKnopf : TRechteckknopf;
        hatPlusKnopf : TRechteckknopf;
        hatTextFeldN1 : TSuMTextfeld;
        hatTextFeldN2 : TSuMTextfeld;
        hatTextFeldN3 : TSuMTextfeld;
        hatTextFeldZ1 : TSuMTextfeld;
        hatTextFeldZ2 : TSuMTextfeld;
        hatTextFeldZ3 : TSuMTextfeld;

     // Methoden
     public
        constructor init; override;
        procedure hatBeendenKnopfClick(sender:TObject);
        procedure hatDurchKnopfClick(sender:TObject);
        procedure hatMalKnopfClick(sender:TObject);
        procedure hatMinusKnopfClick(sender:TObject);
        procedure hatPlusKnopfClick(sender:TObject);

   end;

implementation

//+---------------------------------------------------------------------
//|         TBruchrechnerAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TBruchrechnerAnwendung.init;
begin
  inherited init;
  meinStift := BuntStift.init;

  hatBeendenKnopf     := TRechteckKnopf.init(260,200,200,'Beenden',dieMaus);

  hatTextFeldZ1:=TSuMTextfeld.init(50,100,dieMaus);
  hatPlusKnopf   := TRechteckKnopf.init(hatTextFeldZ1.links+
                                        hatTextFeldZ1.breite+20 ,60,20,'+',dieMaus);
  hatMinusKnopf   := TRechteckKnopf.init(hatTextFeldZ1.links+
                                        hatTextFeldZ1.breite+20 ,100,20,'-',dieMaus);
  hatMalKnopf   := TRechteckKnopf.init(hatTextFeldZ1.links+
                                        hatTextFeldZ1.breite+20 ,155,20,'*',dieMaus);
  hatDurchKnopf   := TRechteckKnopf.init(hatTextFeldZ1.links+
                                        hatTextFeldZ1.breite+20 ,195,20,'/',dieMaus);
  hatTextFeldZ2:=TSuMTextfeld.init(hatTextFeldZ1.links+
                                  hatTextFeldZ1.breite+60,100,dieMaus);

  hatTextFeldZ3:=TSuMTextfeld.init(hatTextFeldZ2.links+
                                 hatTextFeldZ2.breite+60,100,dieMaus);

  with meinStift do begin
     setzeLinienbreite(2);
     hoch;
     bewegeBis(hatTextFeldZ1.links,140);
     runter;
     bewegeBis(hatTextFeldZ1.links+hatTextFeldZ1.breite,140);
     hoch;
     bewegeBis(hatTextFeldZ2.links,140);
     runter;
     bewegeBis(hatTextFeldZ2.links+hatTextFeldZ1.breite,140);

     hoch;
     bewegeBis(hatTextFeldZ3.links-50,135);
     runter;
     bewegeBis(hatTextFeldZ3.links-10,135);
     hoch;
     bewegeBis(hatTextFeldZ3.links-50,145);
     runter;
     bewegeBis(hatTextFeldZ3.links-10,145);


     hoch;
     bewegeBis(hatTextFeldZ3.links,140);
     runter;
     bewegeBis(hatTextFeldZ3.links+hatTextFeldZ1.breite,140)
  end;   

  hatTextFeldN1:=TSuMTextfeld.init(hatTextFeldZ1.links,155,dieMaus);
  hatTextFeldN2:=TSuMTextfeld.init(hatTextFeldZ2.links,155,dieMaus);
  hatTextFeldN3:=TSuMTextfeld.init(hatTextFeldZ3.links,155,dieMaus);

  ErsterKnopf.haengeEreignisBearbeiterAn(hatBeendenKnopf);
  ErsterKnopf.haengeEreignisBearbeiterAn(hatPlusKnopf);
  ErsterKnopf.haengeEreignisBearbeiterAn(hatMinusKnopf);
  ErsterKnopf.haengeEreignisBearbeiterAn(hatMalKnopf);
  ErsterKnopf.haengeEreignisBearbeiterAn(hatDurchKnopf);

  ErsterKnopf.haengeEreignisBearbeiterAn(hatTextFeldZ1);
  ErsterKnopf.haengeEreignisBearbeiterAn(hatTextFeldZ2);
  ErsterKnopf.haengeEreignisBearbeiterAn(hatTextFeldZ3);
  ErsterKnopf.haengeEreignisBearbeiterAn(hatTextFeldN1);
  ErsterKnopf.haengeEreignisBearbeiterAn(hatTextFeldN2);
  ErsterKnopf.haengeEreignisBearbeiterAn(hatTextFeldN3);

  hatBeendenKnopf.meineClickAktion     := hatBeendenKnopfClick;
  hatPlusKnopf.meineClickAktion        := hatPlusKnopfClick;
  hatMinusKnopf.meineClickAktion       := hatMinusKnopfClick;
  hatMalKnopf.meineClickAktion         := hatMalKnopfClick;
  hatDurchKnopf.meineClickAktion       := hatDurchKnopfClick;

  hatBruch1:=TBruch.init(2,3);
  hatTextfeldZ1.setzeInhalt(hatBruch1.zaehler);
  hatTextfeldN1.setzeInhalt(hatBruch1.nenner);

  hatBruch2:=TBruch.init(1,6);
  hatTextfeldZ2.setzeInhalt(hatBruch2.zaehler);
  hatTextfeldN2.setzeInhalt(hatBruch2.nenner);

  hatErgebnisbruch:=TBruch.init(1,1);
  hatTextfeldZ3.setzeInhalt(hatErgebnisbruch.zaehler);
  hatTextfeldN3.setzeInhalt(hatErgebnisbruch.nenner);

  hatBruchrechner:=TBruchrechner.init(hatBruch1,hatBruch2,hatErgebnisbruch);


end;

  // Aktionsteil

//-------- hatBeendenKnopfClick (public) -------------------------------
procedure TBruchrechnerAnwendung.hatBeendenKnopfClick(sender:TObject);
begin
   self.beenden
end;

//-------- hatDurchKnopfClick (public) ---------------------------------
procedure TBruchrechnerAnwendung.hatDurchKnopfClick(sender:TObject);
begin
  hatBruch1.setzeZaehler(hatTextFeldZ1.InhaltAlsGanzeZahl);
  hatBruch1.setzeNenner(hatTextFeldN1.InhaltAlsGanzeZahl);
  hatBruch2.setzeZaehler(hatTextFeldZ2.InhaltAlsGanzeZahl);
  hatBruch2.setzeNenner(hatTextFeldN2.InhaltAlsGanzeZahl);
  hatBruchrechner.dividiere;
  hatTextfeldZ3.setzeInhalt(hatErgebnisbruch.zaehler);
  hatTextfeldN3.setzeInhalt(hatErgebnisbruch.nenner);
end;

//-------- hatMalKnopfClick (public) -----------------------------------
procedure TBruchrechnerAnwendung.hatMalKnopfClick(sender:TObject);
begin
  hatBruch1.setzeZaehler(hatTextFeldZ1.InhaltAlsGanzeZahl);
  hatBruch1.setzeNenner(hatTextFeldN1.InhaltAlsGanzeZahl);
  hatBruch2.setzeZaehler(hatTextFeldZ2.InhaltAlsGanzeZahl);
  hatBruch2.setzeNenner(hatTextFeldN2.InhaltAlsGanzeZahl);
  hatBruchrechner.multipliziere;
  hatTextfeldZ3.setzeInhalt(hatErgebnisbruch.zaehler);
  hatTextfeldN3.setzeInhalt(hatErgebnisbruch.nenner);
end;

//-------- hatMinusKnopfClick (public) ---------------------------------
procedure TBruchrechnerAnwendung.hatMinusKnopfClick(sender:TObject);
begin
  hatBruch1.setzeZaehler(hatTextFeldZ1.InhaltAlsGanzeZahl);
  hatBruch1.setzeNenner(hatTextFeldN1.InhaltAlsGanzeZahl);
  hatBruch2.setzeZaehler(hatTextFeldZ2.InhaltAlsGanzeZahl);
  hatBruch2.setzeNenner(hatTextFeldN2.InhaltAlsGanzeZahl);
  hatBruchrechner.subtrahiere;
  hatTextfeldZ3.setzeInhalt(hatErgebnisbruch.zaehler);
  hatTextfeldN3.setzeInhalt(hatErgebnisbruch.nenner);
end;

//-------- hatPlusKnopfClick (public) ----------------------------------
procedure TBruchrechnerAnwendung.hatPlusKnopfClick(sender:TObject);
begin
  hatBruch1.setzeZaehler(hatTextFeldZ1.InhaltAlsGanzeZahl);
  hatBruch1.setzeNenner(hatTextFeldN1.InhaltAlsGanzeZahl);
  hatBruch2.setzeZaehler(hatTextFeldZ2.InhaltAlsGanzeZahl);
  hatBruch2.setzeNenner(hatTextFeldN2.InhaltAlsGanzeZahl);
  hatBruchrechner.addiere;
  hatTextfeldZ3.setzeInhalt(hatErgebnisbruch.zaehler);
  hatTextfeldN3.setzeInhalt(hatErgebnisbruch.nenner);
end;

end.
